package liiga;

import javafx.fxml.FXML;
import javafx.fxml.FXMLLoader;
import javafx.scene.Parent;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.stage.Stage;
import java.io.IOException;

public class Avausnakyma {

    /// Nappi joka vie näkymään "kerroinvalinta"
    @FXML
    private Button laskeVetoNappi;

    /// Nappi joka vie näkymään "lisaaTulos"
    @FXML
    private Button LisaaTulosNappi;

    /// Nappi joka vie näkymään "ohjeJaTietoja"
    @FXML
    private Button TietojaJaOhjeNappi;

    /// Alustaa etusivun napit ja painettaessa vie oikeaan paikkaan (= vaihtaa näkymää)
    @FXML
    private void initialize() {
        laskeVetoNappi.setOnAction(event -> {
            try {
                vaihdaNakyma("kerroinvalinta.fxml");
            } catch (IOException e) {
                throw new RuntimeException(e);
            }
        });
        LisaaTulosNappi.setOnAction(event -> {
            try {
                vaihdaNakyma("lisaaTulos.fxml");
            } catch (IOException e) {
                throw new RuntimeException(e);
            }
        });
        TietojaJaOhjeNappi.setOnAction(event -> {
            try {
                vaihdaNakyma("ohjeJaTietoja.fxml");
            } catch (IOException e) {
                throw new RuntimeException(e);
            }
        });
    }

    /// Apualiohjelma näkymän vaihtamiseen
    private void vaihdaNakyma(String fxmlTiedosto) throws IOException {

            FXMLLoader loader = new FXMLLoader(getClass().getResource(fxmlTiedosto));
            Parent root = loader.load();

            Stage stage = (Stage) laskeVetoNappi.getScene().getWindow();
            stage.setScene(new Scene(root));
            stage.show();
    }

}
