package liiga;

/**
 * Luokka Joukkue, oliot sisältävät joukkueen nimen sekä ID:n.
 * Osaa palauttaa joukkeen nimen ja ID:n.
 * @author Ollih
 * @version 11 Mar 2025
 *
 */
public class Joukkue {
    
    private int ID;
    private String nimi;
    
    
    /**
     * Luo uuden joukkuuen, asettaa sille ID ja nimen. 
     * @param ID joukkueen ID
     * @param nimi joukkueen nimi
     */
    public Joukkue(int ID, String nimi) {
        this.ID = ID;
        this.nimi = nimi;
    }
    
    /**
     * Palauttaa joukkuuen nimen
     * @return joukkuuen nimi
     */
    public String getNimi() {
        return nimi;
    }
    
    /**
     * Palauttaa joukkuuen ID
     * @return joukkueen ID
     */
    public int getID() {
        return ID;
    }
    
    
    /**
     * Tulostetaan Joukkueen tiedot
     */
    public void tulosta() {
        System.out.println(nimi + " " + ID);
    }
    
    /*
     * Main-funktio.
     * @param args ei käytössä

    public static void main(String[] args) {
        
        
        Joukkue borussia = new Joukkue(1, "Borussia M.Gladbach");
        Joukkue augsburg = new Joukkue(2, "Augsburg");
        
        borussia.tulosta();
        System.out.println(borussia.getNimi() + " " + borussia.getID());
        
        augsburg.tulosta();
        System.out.println(augsburg.getNimi() + " " + augsburg.getID());
       
    }
     */
}

