package liiga;

import java.io.FileNotFoundException;
import java.util.ArrayList;
import java.util.Objects;
import java.util.Scanner;
import java.io.*;

/**
 * @author Ollih
 * Luokka joukkuueet. Ylläpitää listaa joukkueista, eli osaa etsiä sekä lisätä listaan.
 * @version 14 Mar 2025
 *
 */
public class Joukkueet {

    private static final int maxJoukkueet  = 40;
    private int              lkm           = 0;
    @SuppressWarnings("unused")
    private String           tiedostonimi  = "";
    private Joukkue          alkiot[]      = new Joukkue[maxJoukkueet];
    
    public Joukkueet(String tiedosto) {

        Joukkue joukkueet[] = new Joukkue[90];
        int lkm = 0;

        try(Scanner fileInput =  new Scanner(new FileInputStream(tiedosto))){

            fileInput.nextLine();

            while (fileInput.hasNext()) {
                try {

                    String rivi = fileInput.nextLine();
                    String[] osat = rivi.split(",");

                    int ID = Integer.parseInt(osat[1]);
                    String nimi = osat[0];

                    joukkueet[lkm] = new Joukkue(ID, nimi);
                    lkm ++;
                    
                } catch (NumberFormatException ex) {
                    System.err.println("Tapahtui virhe (joukkueet.java)");
                }
            }
        }catch (FileNotFoundException ex) {
            System.err.println("Tiedosto ei aukea!");
        }
        this.alkiot = joukkueet;
        this.lkm = lkm;
    }
    
    /**
     * Lisää joukkueen joukkueiden listaan.
     * @param joukkue = joukkue joka halutaan lisätä
     */
    public void lisaa(Joukkue joukkue){
        if (lkm < alkiot.length) {
            alkiot[lkm] = joukkue;
            lkm++;
        }
    }

    /**
     * palauttaa joukkueiden lukumäärän
     * @return lkm eli joukkueiden lukumäärä listassa.
     */
    public int getLkm() {
        return lkm;
    }

    /**
     * Palauttaa joukkueen, jonka ID annetaan.
     * @param ID = joukkueen ID, jota halutaan etsiä
     * @return palauttaa olion Joukkue, joka vastaa ID:tä.
     */
    public Joukkue getJoukkueFromID(int ID) {

        int i = 0;
        if ( ID < 0 || lkm < ID) {
            throw new IndexOutOfBoundsException("Laiton ID: " + ID);
        }
        while (i < lkm){
            if (alkiot[i].getID() == ID) return alkiot[i];
            i++;
        }
        return alkiot[0];
    }
    
    public Joukkue getJoukkueFromNimi(String nimi) {

        int i = 0;

        while (i < lkm) {

            if (Objects.equals(alkiot[i].getNimi(), nimi)) return alkiot[i];
            i++;
        }
        return alkiot[0];
    }

}
