package liiga;

import javafx.fxml.FXML;
import javafx.fxml.FXMLLoader;
import javafx.scene.Parent;
import javafx.scene.Scene;
import javafx.scene.control.Alert;
import javafx.scene.control.Button;
import javafx.scene.control.ComboBox;
import javafx.stage.Stage;
import java.io.IOException;
import java.util.*;
import java.io.File;
import java.io.FileNotFoundException;

public class Kerroinvalinta extends LisaaTulos {

    // Tarvittavat muuttujat
    public String polkuDataan;
    public String polkuJoukkueisiin;
    public Ottelut ottelut;
    public Joukkueet joukkueet;
    double todnak = 0;

    // Nappi jolla voidaan laskea todennäköisyys
    @FXML Button laskenappi;

    /// Nappi joka vie takaisin etusivulle
    @FXML
    private Button etusivulletakaisin;

    /// Nappi jolla valitaan Bundesliiga 'datalähteeksi'
    @FXML
    private Button bundesLiigalleNappi;

    /// Nappi, jolla valitaan Valioliiga 'datalähteeksi'
    @FXML
    private Button Valioliigallenappi;

    // Pudotusvalikko jolla voidaan valita tietty joukkue, jonka puolesta lyödään veto
    @FXML
    private ComboBox<String> valitsejengi;

    // Nappi jolla valitaan että lyödään veto aina suurimmalle kertoimelle
    @FXML
    private Button suurinkerroinNappi;

    // Nappi jolla valitaan että lyödään veto aina pienimmälle kertoimelle
    @FXML
    private Button pieninkerroinNappi;

    // Nappi jolla valitaan että lyödään veto aina keskimmäiselle kertoimelle
    @FXML
    private Button keskimmainenkerroinNappi;

    // Nappi jolla valitaan että lyödään veto aina kotijoukkueelle
    @FXML
    private Button kotijoukkueNappi;

    // Nappi jolla valitaan että lyödään veto aina vierasjoukkueelle
    @FXML
    private Button vierasjoukkueNappi;

    /// Alustaa näkymän kaikki napit
    @FXML
    private void initialize() {

        // Alustetaan polku Bundesliigaan, polku reagoi ja vaihtuu tarvittaessa liiganvalintanappia painamalla
        polkuDataan = "data/bundesliigatulokset.csv";
        polkuJoukkueisiin = "data/bundesID.csv";

        // Vie käyttäjän takaisin etusivulle
        etusivulletakaisin.setOnAction(event -> {
            try {
                vaihdaNakyma();
            } catch (IOException e) {
                throw new RuntimeException(e);
            }
        });

        // Kun painetaan 'lyö pienimmälle kertoimelle' niin lasketaan todennäköisyys pieninKerroinValittu:ssa.
        pieninkerroinNappi.setOnAction(event -> {
            pieninKerroinValittu();
        });

        // Kun painetaan 'lyö suurimmalle kertoimelle' niin lasketaan todennäköisyys suurinKerroinValittu:ssa.
        suurinkerroinNappi.setOnAction(event -> {
            suurinKerroinValittu();
        });

        // Kun painetaan 'lyö keskimmäiselle kertoimelle' niin lasketaan todennäköisyys keskimmainenKerroinValittu:ssa.
        keskimmainenkerroinNappi.setOnAction(event -> {
            keskimmainenKerroinValittu();
        });

        // Kun painetaan 'lyö veto kotijoukkueelle' niin lasketaan todennäköisyys kotijoukkueValitttu:ssa.
        kotijoukkueNappi.setOnAction(event -> {
            kotiJoukkueValittu();
        });

        // Kun painetaan 'lyö veto vierasjoukkuelle' niin lasketaan todennäköisyys vierasjoukkueValittu:ssa.
        vierasjoukkueNappi.setOnAction(event -> {
            vierasJoukkueValittu();
        });


        /* Kun painetaan 'laske' niin ilmoitetaan käyttäjälle todennäköisyys aiemmin valitun perusteella.
        Esim. suurimmalle kertoimelle (yllä)*/
        laskenappi.setOnAction(event -> {

            String valittuJengi = valitsejengi.getValue();

            if (valittuJengi == null || valittuJengi.isEmpty()) {

            Alert ilmoitus = new Alert(Alert.AlertType.INFORMATION);
            ilmoitus.setTitle(null);
            ilmoitus.setHeaderText(null);
            ilmoitus.setContentText("Tapahtuman todennäköisyys on " + todnak * 100 + "%");
            ilmoitus.showAndWait();
            } else {

            tiettyJoukkueValittu(valittuJengi);
            Alert ilmoitus = new Alert(Alert.AlertType.INFORMATION);
            ilmoitus.setTitle(null);
            ilmoitus.setHeaderText(null);
            ilmoitus.setContentText(valittuJengi + ":in todennäköisyys voitolle on " + todnak * 100 + "%");
            ilmoitus.showAndWait();
            }

            // Resetoidaan ilmoituksen sulkemisen jälkeen
            todnak = 0;
            valitsejengi.setValue(null);

        });
        // Kun valitaan liigaksi Bundesliiga niin polku vaihtuu oikeaksi datan hakemiseksi
        bundesLiigalleNappi.setOnAction(event -> {

            polkuDataan = "data/bundesliigatulokset.csv";
            polkuJoukkueisiin = "data/bundesID.csv";
            joukkueet = new Joukkueet(polkuJoukkueisiin);
            try {
                ottelut = new Ottelut(polkuDataan, joukkueet);
            } catch (FileNotFoundException e) {
                throw new RuntimeException(e);
            }
            paivitaJoukkueLista();

        });

        // Kun valitaan liigaksi Valioliiga niin polku vaihtuu oikeaksi datan hakemiseksi
        Valioliigallenappi.setOnAction(event -> {
            polkuDataan = "data/premierliigatulokset.csv";
            polkuJoukkueisiin = "data/premierID.csv";
            joukkueet = new Joukkueet(polkuJoukkueisiin);
            try {
                ottelut = new Ottelut(polkuDataan, joukkueet);
            } catch (FileNotFoundException e) {
                throw new RuntimeException(e);
            }

            paivitaJoukkueLista();
        });

        // Lisätään "tietylle joukkueelle" -comboboxiin joukkueet.
        List<String> valittavaJengi = haeJoukkueet(polkuJoukkueisiin);
        valitsejengi.getItems().addAll(valittavaJengi);

    }

    // Päivittää pudotusvalikon
    private void paivitaJoukkueLista() {
        List<String> valittavaJengi = haeJoukkueet(polkuJoukkueisiin);
        valitsejengi.getItems().setAll(valittavaJengi);
    }

    /// Pystytään vaihtamaan näkymä, käytetään apuna "takaisin etusivulle" -napissa.
    private void vaihdaNakyma() throws IOException {

        FXMLLoader loader = new FXMLLoader(getClass().getResource("avausnakyma.fxml"));
        Parent root = loader.load();

        Stage stage = (Stage) etusivulletakaisin.getScene().getWindow();
        stage.setScene(new Scene(root));
        stage.show();
    }

    // Lasketaan aina isoimmalle kertoimelle lyödyn vedon voittotodennnäköisyys
    private void suurinKerroinValittu(){
        
        int suurinMaara = 0;
        
        List <Ottelu> tasapelit = ottelut.getTulokset('A');
        List <Ottelu> kotiVoitti = ottelut.getTulokset('H');
        List <Ottelu> vierasVoitti = ottelut.getTulokset('D');
        
        for(Ottelu ottelu : tasapelit) {
            if (ottelu.getSuurinKerroin() == ottelu.getTasuriKerroin()) suurinMaara++;
        }
        for(Ottelu ottelu : kotiVoitti) {
            if (ottelu.getSuurinKerroin() == ottelu.getKotiKerroin()) suurinMaara++;
        }
        for(Ottelu ottelu : vierasVoitti) {
            if (ottelu.getSuurinKerroin() == ottelu.getVierasKerroin()) suurinMaara++;
        }


        todnak = (double) suurinMaara / ottelut.getAlkiot().size();
    }

    // Lasketaan aina pienimmälle kertoimelle lyödyn vedon voittotodennnäköisyys
    private void pieninKerroinValittu(){
        
        int pieninMaara = 0;
        
        List <Ottelu> tasapelit = ottelut.getTulokset('A');
        List <Ottelu> kotiVoitti = ottelut.getTulokset('H');
        List <Ottelu> vierasVoitti = ottelut.getTulokset('D');
        
        for(Ottelu ottelu : tasapelit) {
            if (ottelu.getPieninKerroin() == ottelu.getTasuriKerroin()) pieninMaara++;
        }
        for(Ottelu ottelu : kotiVoitti) {
            if (ottelu.getPieninKerroin() == ottelu.getKotiKerroin()) pieninMaara++;
        }
        for(Ottelu ottelu : vierasVoitti) {
            if (ottelu.getPieninKerroin() == ottelu.getVierasKerroin()) pieninMaara++;
        }


        todnak = (double) pieninMaara / ottelut.getAlkiot().size();
    }
    // Laske
    //Lasketaan aina keskimmäiselle kertoimelle lyödyn vedon voittotodennnäköisyys
    private void keskimmainenKerroinValittu(){
        
        int keskimmainenMaara = 0;
        
        List <Ottelu> tasapelit = ottelut.getTulokset('A');
        List <Ottelu> kotiVoitti = ottelut.getTulokset('H');
        List <Ottelu> vierasVoitti = ottelut.getTulokset('D');
        
        for(Ottelu ottelu : tasapelit) {
            if (ottelu.getKeskimmainenKerroin() == ottelu.getTasuriKerroin()) keskimmainenMaara++;
        }
        for(Ottelu ottelu : kotiVoitti) {
            if (ottelu.getKeskimmainenKerroin() == ottelu.getKotiKerroin()) keskimmainenMaara++;
        }
        for(Ottelu ottelu : vierasVoitti) {
            if (ottelu.getKeskimmainenKerroin() == ottelu.getVierasKerroin()) keskimmainenMaara++;
        }


        todnak = (double) keskimmainenMaara / ottelut.getAlkiot().size();
    }

    // Lasketaan aina kotijoukkueelle lyödyn vedon voittotodennnäköisyys
    private void kotiJoukkueValittu(){
        
        todnak = ottelut.otteluidenKotiKerroin();
    }

    // Lasketaan aina vierasjoukkueelle lyödyn vedon voittotodennnäköisyys
    private void vierasJoukkueValittu(){
        
        todnak = ottelut.otteluidenVierasKerroin();
    }

    /* Lasketaan valitun joukkueen voittotodennnäköisyys. Esim. kun valitaan Bayern Munchen
    niin tässä lasketaan kaikki Bayernin pelaamat pelit ja voittojen osuus näistä kaikista peleistä. */
    private void tiettyJoukkueValittu(String jengi){

        int voitetutottelut = 0;

        Joukkue haluttuJengi = joukkueet.getJoukkueFromNimi(jengi);

        List<Ottelu> kotiottelut = ottelut.getJoukkueenKotiottelut(haluttuJengi);

        List<Ottelu> vierasottelut = ottelut.getJoukkueenVierasottelut(haluttuJengi);

        for(int i = 0; i < vierasottelut.size(); i++){

            if(vierasottelut.get(i).getTulos() == 'A'){
                voitetutottelut++;
            }
        }

        for (Ottelu ottelu : kotiottelut) {

            if (ottelu.getTulos() == 'H') {
                voitetutottelut++;
            }
        }

        todnak = (double) voitetutottelut / (vierasottelut.size()+kotiottelut.size());
    }

}
