package liiga;

import java.util.Arrays;

/**
 * Luokka Ottelu, osaa lukea ja kirjoittaa tietyn ottelun tiedot.
 * Avustajana Joukkue.
 * @author Ollih
 * @version 11 Mar 2025
 *
 */
public class Ottelu {
    
    private Joukkue kotiJoukkue;
    private Joukkue vierasJoukkue;
    private float kotiKerroin;
    private float vierasKerroin;
    private float tasuriKerroin;
    private char loppuTulos;
    
    /**
     * Luo ottelun kaikilla tiedoilla
     * @param joukkueet = joukkueiden lista
     * @param koti = kotijoukkue
     * @param vieras = vierasjoukkue
     * @param kotiK = kotijoukkueen kerroin otteluun
     * @param vierasK = vierasjoukkueen kerroin otteluun
     * @param tasuriK = tasapelin kerroin otteluun
     * @param tulos = miten ottelu päättyi. H = koti, A = vieras, D = tasapeli
     */
    public Ottelu(Joukkueet joukkueet, int koti, int vieras, float kotiK, float vierasK, float tasuriK, char tulos) {
        this.kotiJoukkue = joukkueet.getJoukkueFromID(koti);
        this.vierasJoukkue = joukkueet.getJoukkueFromID(vieras);
        this.kotiKerroin = kotiK;
        this.vierasKerroin = vierasK;
        this.tasuriKerroin = tasuriK;
        this.loppuTulos = tulos;
    }
    public double getPieninKerroin() {
        double[] kertoimet = {kotiKerroin, tasuriKerroin, vierasKerroin};
        Arrays.sort(kertoimet);
        return kertoimet[0];
        
    }
    public double getSuurinKerroin() {
        double[] kertoimet = {kotiKerroin, tasuriKerroin, vierasKerroin};
        Arrays.sort(kertoimet);
        return kertoimet[2];
        
    }
    public double getKeskimmainenKerroin() {
        double[] kertoimet = {kotiKerroin, tasuriKerroin, vierasKerroin};
        Arrays.sort(kertoimet);
        return kertoimet[1];
    }
    
    
    public char getTulos() {
        return loppuTulos;
    }
    public Joukkue getKotijoukkue() {
        return kotiJoukkue;
    }
    public Joukkue getVierasjoukkue() {
        return vierasJoukkue;
    }
    public double getVierasKerroin() {
        return vierasKerroin;
    }
    public double getKotiKerroin() {
        return kotiKerroin;
    }
    public double getTasuriKerroin() {
        return tasuriKerroin;
    }
    /**
     * Tulostaa ottelun tiedot.
     */
    public void tulosta() {
        System.out.println(kotiJoukkue.getNimi() + " kerroin: " + kotiKerroin);
        System.out.println(vierasJoukkue.getNimi() + " kerroin: " + vierasKerroin);
        System.out.println("Tasapelin kerroin: " + tasuriKerroin);
        System.out.println("Lopputulos: " + loppuTulos);
        
    }
    
    /**
     * Main-funktio.
     * @param args ei käytössä
     */
    /*
    public static void main(String[] args) {
        
        Joukkueet joukkueet = new Joukkueet();
        Joukkue borussia = new Joukkue(1, "Borussia M.Gladbach");
        Joukkue augsburg = new Joukkue(2, "Augsburg");
        
        joukkueet.lisaa(borussia);
        joukkueet.lisaa(augsburg);
        
        
        Ottelu ottelu = new Ottelu(joukkueet,1,2,4.4f,4.4f,1.6f,'D');
        
        ottelu.tulosta();
        
    }*/
}
