package liiga;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.util.*;
import java.util.Scanner;

/**
 * Ylläpitää luokan Ottelu listaa
 * @author Ollih
 * @version 14 Mar 2025
 *
 */
public class Ottelut {
    
    @SuppressWarnings("unused")
    private int      lkm                        = 0;
    
    // Tarkoitus joskus lukea ottelut jostain tiedostosta.
    @SuppressWarnings("unused")
    private String   tiedostonimi               = "";
    private          ArrayList<Ottelu> alkiot   = new ArrayList<>();
    @SuppressWarnings("unused")
    private String   nimi;

    /**
     * @param tiedosto = tiedoston nimi
     * @param joukkueet = joukkueet, jotka pelaavat kyseisessä liigassa
     */
    public Ottelut(String tiedosto, Joukkueet joukkueet) throws FileNotFoundException {

        File tied = new File(tiedosto);
        Scanner skanneri = new Scanner(tied);
        ArrayList<Ottelu> ottelut = new ArrayList<Ottelu>();

            while (skanneri.hasNextLine()) {
                try {
                    String rivi = skanneri.nextLine();
                    try {

                        int i = 0;
                        int viimeisinPilkku = -1;
                        int kotiJoukkue = -1;
                        int vierasJoukkue = -1;
                        float kotiKerroin = -1;
                        float vierasKerroin = -1;
                        float tasuriKerroin = -1;
                        char lopputulos = 'E';

                        for (int ii = 0; i < rivi.length(); ii++) {

                            if (rivi.charAt(ii) == ','){

                                String valiaikainen = rivi.substring(viimeisinPilkku + 1,ii);

                                if (i == 0) kotiJoukkue = Integer.parseInt(valiaikainen);
                                if (i == 1) vierasJoukkue = Integer.parseInt(valiaikainen);
                                if (i == 2) kotiKerroin = Float.parseFloat(valiaikainen);
                                if (i == 3) vierasKerroin = Float.parseFloat(valiaikainen);
                                if (i == 4) {
                                    tasuriKerroin = Float.parseFloat(valiaikainen);
                                    lopputulos = rivi.charAt(ii + 1);
                                    break;

                                }
                                viimeisinPilkku = ii;
                                i++;

                            }
                        }
                        ottelut.add(new Ottelu(joukkueet,kotiJoukkue,vierasJoukkue,kotiKerroin,vierasKerroin,tasuriKerroin,lopputulos));

                    }catch (NumberFormatException ex) {
                        //hylätään
                    }

                }catch (NumberFormatException ex) {
                        //hylätään

                }
            }

        this.alkiot = ottelut;
    }
    
    /**
     * Lisää ottelut olion listaan alkiot uuden ottelun
     * @param ottelu = ottelu joka halutaan lisätä listaan
     */
    public void lisaa(Ottelu ottelu) {
        alkiot.add(ottelu);
        lkm++;
    }
    
    /**
     * @param tulos = pelin tulos jota halutaan etsiä
     * @return loydetyt = lista kaikista peleistä, joissa haluttu lopputulos.
     */
    public List<Ottelu> getTulokset(char tulos){
        List<Ottelu> loydetyt = new ArrayList<Ottelu>();
        for (Ottelu ottelu : alkiot)
            if (ottelu.getTulos() == tulos) loydetyt.add(ottelu);
        return loydetyt;
    }
    
    public ArrayList<Ottelu> getAlkiot(){
        return alkiot;
    }
    
    public double otteluidenKotiKerroin() {
        int kotiVoitti = 0;
        
        for(Ottelu ottelu : alkiot){
            if (ottelu.getTulos() == 'H') {
                kotiVoitti++;
            }
        }
        return (double) kotiVoitti / alkiot.size();
    }
    
    public double otteluidenVierasKerroin() {
        int vierasVoitti = 0;
        
        for(Ottelu ottelu : alkiot){
            if (ottelu.getTulos() == 'A') {
                vierasVoitti++;
            }
        }
        return (double) vierasVoitti / alkiot.size();
    }
    

    
    /**
     * @param joukkue = joukkue, jonka kotiotteluita etsitään
     * @return loydetyt = ArrayList joukkueen kaikista kotiotteluista.
     */
    public List<Ottelu> getJoukkueenKotiottelut(Joukkue joukkue){
        List<Ottelu> loydetyt = new ArrayList<Ottelu>();
        for (Ottelu ottelu : alkiot)
            if (ottelu.getKotijoukkue() == joukkue) loydetyt.add(ottelu);
        return loydetyt;
    }
    
    /**
     * @param joukkue = joukkue, jonka vierasotteluita etsitään
     * @return loydetyt = ArrayList joukkueen kaikista vierasotteluista.
     */
    public List<Ottelu> getJoukkueenVierasottelut(Joukkue joukkue){
        List<Ottelu> loydetyt = new ArrayList<Ottelu>();
        for (Ottelu ottelu : alkiot)
            if (ottelu.getVierasjoukkue() == joukkue) loydetyt.add(ottelu);
        return loydetyt;
    }
    
    /**
     * main-funktio
     * @param args ei käytössä
     */
    /*
    public static void main(String[] args) {
        
        
        Joukkueet joukkueet = new Joukkueet();
        Joukkue borussia = new Joukkue(1, "Borussia M.Gladbach");
        Joukkue augsburg = new Joukkue(2, "Augsburg");
        joukkueet.lisaa(borussia);
        joukkueet.lisaa(augsburg);
        
        Ottelut ottelut = new Ottelut("testi.csv","nimi", joukkueet);
        
        
      //Tulostaa augsburgin 1. kotiottelun
        ottelut.getJoukkueenKotiottelut(augsburg).get(0).tulosta();
        System.out.println();
      //Tulostaa augsburgin 1. vierasottelun
        ottelut.getJoukkueenVierasottelut(augsburg).get(0).tulosta();
        System.out.println();
        
      //Tulostaa borussian 1. kotiottelun
        ottelut.getJoukkueenKotiottelut(borussia).get(0).tulosta();
        System.out.println();
        //Tulostaa borussian 1. vierasottelun
        ottelut.getJoukkueenVierasottelut(borussia).get(0).tulosta();
        System.out.println();
        
        //Tulostaa 1. tasapelin
        ottelut.getTulokset('D').get(0).tulosta();
        System.out.println();
        //Tulostaa 1. vierasvoiton
        ottelut.getTulokset('A').get(0).tulosta();
        System.out.println();
        

    }

     */
}
